dashboard/urls.py
from django.urls import path
from . import views

app_name = 'dashboard'

urlpatterns = [
    path('', views.index, name='index'),
    path('replot/', views.replot, name='replot'),
]

insubri_parks/urls.py
from django.contrib import admin
from django.urls import path, include
from django.views.generic.base import TemplateView
from dashboard.collect_tweets import collect_tweets

urlpatterns = [
    path('', TemplateView.as_view(template_name='home.html'), name='home'),
    path('webgisMCDM/', include('webgis.urls')),
    path('webgis/', include('insubriparkswebgis.urls')),
    path('admin/', admin.site.urls),
    path('accounts/', include('django.contrib.auth.urls')),
    path('home-dashboard/', TemplateView.as_view(template_name='home-dashboard.html'), name='home-dashboard'),
    path('dashboard/', include('dashboard.urls')),
]

collect_tweets()
handler404 = 'webgis.views.handler404'
handler500 = 'webgis.views.handler500'

webgis/urls.py
from django.urls import path

from . import views

app_name = 'webgis'   #used to separate different app in the html files url app: name path
urlpatterns = [
    path('', views.index, name='index'),
    path('results/', views.results, name='results'),
]


dashboard/models.py
from django.contrib.postgres.fields import ArrayField
from django.db import models

class Tweet(models.Model):
    created_at = models.CharField(max_length=200)
    timestamp = models.CharField(max_length=200)
    id = models.CharField(max_length=200, primary_key=True)
    text = models.CharField(max_length=400)
    source =models.CharField(max_length=400)
    user_id = models.CharField(max_length=200)
    user_screen_name = models.CharField(max_length=200)
    point_coordinates_long = models.FloatField(null=True)
    point_coordinates_lat = models.FloatField(null=True)
    place = models.CharField(max_length=200)
    rectangle_coordinates_long_min = models.FloatField()
    rectangle_coordinates_long_max = models.FloatField()
    rectangle_coordinates_lat_min = models.FloatField()
    rectangle_coordinates_lat_max = models.FloatField()
    hashtags = ArrayField(models.CharField(max_length=400), null=True)

dashboard/views.py
from django.shortcuts import render
from django.contrib.auth.decorators import login_required
# from django.db.models import Q
import pandas as pd
from .models import Tweet

def group_by_day(timestamp):
    tweets_json_aggregated_day = []

    if timestamp:
        tweets_dict_timestamp = {'timestamp': timestamp}
        tweets_df_timestamp = pd.DataFrame(tweets_dict_timestamp)

        tweets_df_timestamp.index = tweets_df_timestamp['timestamp']
        # print(tweets_df_timestamp)
        tweets_df_aggregated_day = tweets_df_timestamp.groupby(tweets_df_timestamp.index.date).count().reset_index()
        tweets_df_aggregated_day.columns = ['date', 'count']
        tweets_df_aggregated_day['date'] = tweets_df_aggregated_day['date'].astype(str)
        # print(tweets_df_aggregated_day)

        tweets_json_aggregated_day = tweets_df_aggregated_day.to_json(orient='records')
        # print(tweets_json_aggregated_day)

    return tweets_json_aggregated_day


@login_required
def index(request):
    tweets = Tweet.objects.all()

    timestamp = []
    # longitude = []
    # latitude = []
    # place_center_longitude = []
    # place_center_latitude = []

    for tweet in tweets:
        timestamp.append(pd.Timestamp(int(tweet.timestamp), unit='ms'))
        # longitude.append(tweet.point_coordinates_long)
        # latitude.append(tweet.point_coordinates_lat)
        # place_center_longitude.append((tweet.rectangle_coordinates_long_min+tweet.rectangle_coordinates_long_max)/2)
        # place_center_latitude.append((tweet.rectangle_coordinates_lat_min+tweet.rectangle_coordinates_lat_max)/2)

    '''
    tweets_dict = {'timestamp': timestamp,
                   'longitude': longitude,
                   'latitude': latitude,
                   'place_center_longitude': place_center_longitude,
                   'place_center_latitude': place_center_latitude}
    tweets_df = pd.DataFrame(tweets_dict)
    '''

    tweets_json_aggregated_day = group_by_day(timestamp)

    return render(request, 'dashboard/index.html', {'tweets_json_aggregated_day': tweets_json_aggregated_day})


def replot(request):
    hashtag = request.POST.get('hashtag', '')
    # print(hashtag)

    # tweets = Tweet.objects.filter(Q(text__icontains=hashtag)|Q(hashtags__icontains=[hashtag]))
    tweets = Tweet.objects.filter(text__icontains=hashtag)

    timestamp = []

    for tweet in tweets:
        timestamp.append(pd.Timestamp(int(tweet.timestamp), unit='ms'))
        # print(tweet.text)
        # print(tweet.hashtags)

    tweets_json_aggregated_day = group_by_day(timestamp)

    return render(request, 'dashboard/index.html', {'tweets_json_aggregated_day': tweets_json_aggregated_day})

dashboard/templates/dashboard/index.html
{% load static %}

<!DOCTYPE html>
<html>
<head>
  <meta charset="utf-8">
  <link href="https://fonts.googleapis.com/css?family=Overpass&display=swap" rel="stylesheet">
  <link rel="stylesheet" href="{% static 'dashboard/node_modules/leaflet/dist/leaflet.css' %}">
  <link rel="stylesheet" href="{% static 'dashboard/js/libraries/jquery-ui-1.12.1/jquery-ui.min.css' %}">
  <link rel="stylesheet" href="{% static 'dashboard/node_modules/bootstrap/dist/css/bootstrap.min.css' %}">
  <script src="{% static 'dashboard/node_modules/leaflet/dist/leaflet.js' %}"></script>
  <script src="{% static 'dashboard/node_modules/jquery/dist/jquery.min.js' %}"></script>
  <script src="{% static 'dashboard/js/libraries/jquery-ui-1.12.1/jquery-ui.min.js' %}"></script>
  <script src="{% static 'dashboard/node_modules/bootstrap/dist/js/bootstrap.min.js' %}"></script>
  <script src="{% static 'dashboard/node_modules/d3/dist/d3.min.js' %}"></script>
  <!-- <script src="https://unpkg.com/@ngageoint/leaflet-geopackage@2.0.5/dist/leaflet-geopackage.min.js"></script> -->
  <!-- <script src="{% static 'dashboard/js/libraries/leaflet-geopackage.min.js' %}"></script> -->
  <link rel="stylesheet" type="text/css" href="{% static 'dashboard/css/main.css' %}">
  <link rel="stylesheet" type="text/css" href="{% static 'dashboard/css/map.css' %}">
  <link rel="stylesheet" type="text/css" href="{% static 'dashboard/css/plot.css' %}">
  <title>{% block title %}INSUBRI.PARKS{% endblock %}</title>
</head>
<body>
  <div class="container-fluid">
      <div class="row">
          <div class="col-lg-5">
            <div class="dashboard-section">
              <div class="dashboard-title">Parks of Insubria</div>
              <div id="map"></div>
            </div>
          </div>
          <div class="col-lg-5">
            <div class="dashboard-section">
              <div class="dashboard-title">Crowdsourced Data</div>
              <div id="plot">
                <div id="date">
                  Date: <span id="date-label-1">13/02/2020</span>–<span id="date-label-2"></span>
                  <div id="date-slider"></div>
                </div>
                <div id="form-replot">
                  <form action="{% url 'dashboard:replot' %}" method="post">
                    {% csrf_token %}
                    <input type="text" name="hashtag" placeholder="Search the tweets...">
                    <input type="submit" value="Replot">
                  </form>
                </div>
              </div>
            </div>
          </div>
      </div>
    </div>
  <script>
    var boscoDelPenzDirectory = "{% static 'dashboard/geojson/bosco_del_penz.geojson' %}";
    var campoDeiFioriDirectory = "{% static 'dashboard/geojson/campo_dei_fiori.geojson' %}";
    var goleDellaBreggiaDirectory = "{% static 'dashboard/geojson/gole_della_breggia.geojson' %}";
    var pinetaDirectory = "{% static 'dashboard/geojson/pineta.geojson' %}";
    var spinaVerdeDirectory = "{% static 'dashboard/geojson/spina_verde.geojson' %}";

    var tweetsJsonAggregatedDay = JSON.parse('{{ tweets_json_aggregated_day | escapejs }}');
  </script>
  <script src="{% static 'dashboard/js/map.js' %}"></script>
  <script src="{% static 'dashboard/js/plot.js' %}"></script>
</body>
</html>